Program PicProg2;

Uses
  Dos, CRT, Timer;

Type
  String2 = String[2];
  String4 = String[4];

CONST
  InName = 'FLASH2.HEX';
  OutName = 'READPIC.DAT';
  Bcolor = 9;
  Fcolor = 7;
  Scolor = 12;
  {This is OK for Mono screens.}
  {Bcolor = 0;
  Fcolor = 7;
  Scolor = 0;}

{' LPT port bit assignments}

{'DonMac.002
'Combination of both used because of difference between transistors and 4066
'enables. Use non-inverting chip. IE: 74xx07 or National 74C906.
'DonMac.002

' ONLY use these if H/W uses 74xx07}
 DataInv = 0;
{ VppOn = 8;
  VppOff = 0;
  VddOn = 4;
  VddOff = 0;}
  ClkHi = 2;
  ClkLo = 0;
  OutHi = 1;
  OutLo = 0;

  DataIn = 64;

{ ONLY use these if H/W uses 74xx06}
  {DataInv = DataIn;}
  VppOn   = 0;
  VppOff  = 8;
  VddOn   = 0;
  VddOff  = 4;
{ ClkHi   = 0;
  ClkLo   = 2;
  OutHi   = 0;
  OutLo   = 1;}

  p0000 = VppOff + VddOff + ClkLo + OutLo;
  p0100 = VppOff + VddOn + ClkLo + OutLo;
  p0101 = VppOff + VddOn + ClkLo + OutHi;
  p1100 = VppOn + VddOn + ClkLo + OutLo;
  p1101 = VppOn + VddOn + ClkLo + OutHi;
  p1110 = VppOn + VddOn + ClkHi + OutLo;
  p1111 = VppOn + VddOn + ClkHi + OutHi;

{ 16C84 serial programming commands}

  LdConf = 0;
  LdProg = 2;
  RdProg = 4;
  IncAdd = 6;
  BegPrg = 8;
  LdData = 3;
  RdData = 5;
  ProgMem = 0;
  DataMem = 1;
  ProgSize = 1024;
  DataSize = 64;
  CodeProtect = 16;
  PWRTE = 8;
  WDTE = 4;
  RC = 3;
  HS = 2;
  XT = 1;
  LP = 0;

  INHX16 = 16;
  INHX8M = 8;

  ProgName = 'PIC84PGM Programmer';
  Version = '1.0';
  Date = '16-Jul-1995';
  Copyright = 'Copyright (C) 1995 Nigel Goodwin.';

  ERRPRG = 0;
  ERRVER = 1;
  ERRLPT = 2;
  ERRFSE = 3;
  ERRHEX = 4;
  ERRFIL = 5;
  ERRNOF = 6;
  ERRHWF = 7;
  VppDly = 100;
  PrgDly = 15;
  Off    = False;
  On     = True;
  High   = False;
  Low    = True;
  WDTPosX = 14;
  WDTPosY = 3;
  PutPosX = 25;
  PutPosY = 3;
  CPPosX  = 35;
  CPPosY  = 3;
  PortPosX = 47;
  PortPosY = 3;
  HexPosX  = 67;
  HexPosY  = 3;
  FNmPosX  = 28;
  FNmPosY  = 5;
  DNmPosX  = 61;
  DNmPosY  = 5;

{ Global variables}
Var
  ProgBuf : Array[0..ProgSize - 1] Of Word ;
  DataBuf : Array[0..DataSize - 1] Of Word ;
  RdProgBuf : Array[0..ProgSize - 1] Of Word ;
  RdDataBuf : Array[0..DataSize - 1] Of Word ;
  InFile,
  OutFile : Text;
  FileBuf : String;
  FilePos : Byte;
  LptPort : Word;
  Check   : Word;
  HexType, Fuses : Byte;
  ProgLoaded, DataLoaded : Boolean;

{DonMac.001 Changes by Don McKenzie...
'User set Parameters and Auto-detect Printer Port.}
  PP, {' Printer Port.}
  HE, {' HexType.}
  HF, {' HexFile Name.}
  DF, {' DataFile.}
  WT, {' Watchdog Timer}
  PT, {' Power up timer.}
  CODE : String; {' Code Protection.}
  Osc : Byte;

Procedure DisplayBuf(Which, BufType, Page : Byte); Forward;
Procedure ClearUp; Forward;
Procedure ShowStats; Forward;

Procedure Color(FC, BC : Byte);
Begin
  TextColor(FC);
  TextBackGround(BC);
End;

Procedure WriteAt(x, y : Byte; InStr : String);
Var
  CursorX,
  CursorY,
  X1, Y1,
  X2, Y2 : Byte;
Begin
  CursorX := WhereX;
  CursorY := WhereY;
  X1 := Lo(WindMin)+1;
  Y1 := Hi(WindMin)+1;
  X2 := Lo(WindMax)+1;
  Y2 := Hi(WindMax)+1;
  Window(1, 1, 80, 25);
  GotoXY(x, y);
  COLOR(Black, Fcolor);
  Write(InStr);
  COLOR(Fcolor, Bcolor);
  Window(X1, Y1, X2, Y2);
  GotoXY(CursorX, CursorY);
End;

Procedure AskFuses;
Var
  A : Byte;
Begin
  Fuses := 0;
{  A := Osc;
  WriteLN('                        Oscillator is ', A);
  CASE A Of
    'LP' : Osc := LP;
    CASE "XT", "xt": Osc = XT
    CASE "HS", "hs": Osc = HS
    CASE "RC", "rc": Osc = RC
    CASE ELSE: Osc = LP
  End;}
  Fuses := Osc + CodeProtect;
  {A$ = WT$
  WriteLN( "              Watchdog timer Enabled? "; A$
  IF Yes(A$) THEN Fuses = Fuses + WDTE
  A$ = PT$
  WriteLN( "              Power up timer Enabled? "; A$
  IF Yes(A$) THEN Fuses = Fuses + PWRTE
  A$ = CODE$
  WriteLN( "             Code Protection Enabled? "; A$
  IF Yes(A$) THEN Fuses = Fuses - CodeProtect;}
  ShowStats;
End;

Procedure ProgMode(SetMode : Boolean);
Begin
  If SetMode Then  {Turn on Program mode}
  Begin
    Port[LptPort] := p0100;   {VppOff + VddOn + ClkLo + OutLo}
    Delay(VppDly);
    Port[LptPort] := p1100;   {VppOn + VddOn + ClkLo + OutLo}
  End
  Else             {Turn Off program mode}
  Begin
    Port[LptPort] := p0100;  {VppOff + VddOn + ClkLo + OutLo}
    Delay(VppDly);
    Port[LptPort] := p0000;  {VppOff + VddOff + ClkLo + OutLo}
  End;
End;

Procedure ClockPulse(SetMode : Boolean);
Begin
  If SetMode Then   {send low pulse}
  Begin
    Port[LptPort] := p1110;   {VppOn + VddOn + ClkHi + OutLo}
    Port[LptPort] := p1100;   {VppOn + VddOn + ClkLo + OutLo}
  End
  Else              {Send high pulse}
  Begin
    Port[LptPort] := p1111;  {VppOn + VddOn + ClkHi + OutHi}
    Port[LptPort] := p1101;  {VppOn + VddOn + ClkLo + OutHi}
  End;
End;

Procedure Command(Cmd : Byte); {Send a progamming command to PIC}
Var
  BitPos : Byte;
Begin
   Port[LptPort] := p1100; {VppOn + VddOn + ClkLo + OutLo}
   BitPos := 1;
   WHILE BitPos <= 32 Do
   Begin
     IF (Cmd AND BitPos) = BitPos THEN
       ClockPulse(High)
     ELSE
       ClockPulse(Low);
     BitPos := BitPos Shl 1;
   End;
   Port[LptPort] := p1101; {VppOn + VddOn + ClkLo + OutHi}
End;

Procedure GetInput(Query, DefVal, A : String);
Begin
  WriteLN( Query, ' (', DefVal, ') ');
  ReadLN(A);
  IF Length(A) = 0 THEN
    A := DefVal;
End;

Function HexNibble ( Number : Byte ) : Char;
Begin
  If Number < 10 Then HexNibble := Chr(48+Number)
                 Else HexNibble := Chr(55+Number);
End;

Function Hexs(Number : Byte) : String2;
Begin
  Hexs := HexNibble(Number Div 16) + HexNibble(Number Mod 16);
End;

Function WordHexs(Number : Word) : String4;
Begin
  WordHexs := Hexs(Number Div 256) + Hexs(Number Mod 256);
End;

Procedure Quit (ErrNum : Byte; Wanted, Got, Addr : Word);
Var
  TempStr : String;
Begin
  TempStr := 'Address ' + WordHEXS(Addr) + ' : ' + WordHEXS(Wanted) + ' ' + WordHEXS(Got);
  COLOR(Bcolor, Fcolor);
  CASE ErrNum Of
    ERRPRG:  WriteLN('Programming Failed ', TempStr);
    ERRVER:  WriteLN('Verify Failed ', TempStr);
    ERRLPT:  WriteLN('Unlikely LPT port ', HEXS(Got));
    ERRFSE:  WriteLN('Fuse Failure ', TempStr);
    ERRFIL:  WriteLN('Can''t open Hex file');
    ERRHEX:  WriteLN('Bad Hex file');
    ERRNOF:  WriteLN('Nothing to Do');
    ERRHWF:  WriteLN('Hardware Fault - check power, connections and port');
  End;
  ProgMode(Off);
  {BEEP}
  GotoXY(1,22);
  COLOR(Fcolor, Bcolor);
{  GetInput('Start over (Y/N)', 'N', A);
  IF Yes(A$) THEN RUN}
  ClearUp;
End;


FUNCTION HexDigit : Byte;
Var
  d : Byte;
Begin
  d := Ord(FileBuf[FilePos]);
  Inc(FilePos);
  IF d > Ord('9') THEN
    d := d - Ord('A') + 10
  ELSE
    d := d - Ord('0');
  IF (d < 0) OR (d > 15) THEN
    Quit( ERRHEX, 0, 0, 0);
  HexDigit := d;
END;

FUNCTION HexByte : Byte;
Var
  B : Byte;
Begin
  B := HexDigit;
  B := 16 * B + HexDigit;
  Check := Check + B;
  HexByte := B;
End;

FUNCTION HexWord : Word;
Var
  w : Word;
Begin
  w := HexByte;
  w := 256 * w + HexByte;
  HexWord := w;
End;

FUNCTION InWord : Word;
Var
  BitPos,
  TempWord : Word;
  Bit : Byte;

Begin
  ClockPulse(High); {Get start bit}
  TempWord := 0;
  BitPos := 1;
  WHILE BitPos <= 8192 Do
  Begin
    ClockPulse(High);
    Bit := (Port[LptPort + 1] AND DataIn) XOR DataInv;
    IF Bit <> 0 THEN
      TempWord := TempWord + BitPos;
    BitPos := BitPos Shl 1;
  End;
  ClockPulse(High);  {Get stop bit}
  InWord := TempWord;
End;


Procedure LoadHex (InName : String; Which, BufSize : Word);
Var
  RecType,
  wHi,
  wLo,
  i : Byte;
  NWords,
  Address,
  DataOffSet,
  w : Word;
  Eol : String2;
Begin
  {$I-}
  Assign(InFile, InName);
  Reset(InFile);
  If IOResult <> 0 Then
    Quit(ERRFIL , 0, 0, 0);
  RecType := 0;
  WHILE RecType <> 1 Do
  Begin
    ReadLN(InFile, FileBuf);
    If IOResult <> 0 Then
      Quit(ERRFIL , 0, 0, 0);
    IF FileBuf[1] <> ':' THEN
      Quit(ERRHEX, 0, 0, 0);
    Check := 0;
    FilePos := 2;
    w := HexByte;  {Get number of words}
    IF HexType = INHX8M THEN
      NWords := w Div 2
    ELSE
      NWords := w;
    w := HexWord;
    IF HexType = INHX8M THEN        {Get load address}
      Address := w Div 2
    ELSE
      Address := w;
    DataOffSet := Address;
    RecType := HexByte;  {check for last line}
    FOR i := 1 TO NWords Do
    Begin
      wHi := HexByte;
      wLo := HexByte;
      IF HexType = INHX8M THEN
        w := 256 * wLo + wHi
      ELSE
        w := 256 * wHi + wLo;
      IF Which = ProgMem THEN
      Begin
        IF Address < BufSize THEN
          ProgBuf[Address] := w;
        End
      ELSE
      Begin
        IF Address-DataOffSet < BufSize THEN
          DataBuf[Address-DataOffSet] := w;
      End;
      Address := Address + 1;
    End;
    w := HexByte;
    Eol := FileBuf[FilePos] + FileBuf[FilePos+1];
    Check := Check AND $FF;
    IF Check <> 0 THEN
      Quit(ERRHEX, 0, 0, 0);
  End;
  {$I+}
  Close(InFile);
End;

Procedure OutWord(Data : Word);
Var
  BitPos : Word;
Begin
  ClockPulse(Low);
  BitPos := 1;
  WHILE BitPos <= 8192 Do
  Begin
    IF (Data AND BitPos) = BitPos THEN
      ClockPulse(High)
    ELSE
      ClockPulse(Low);
    BitPos := BitPos Shl 1;
  End;
  ClockPulse(Low);
End;

Procedure ProgramChip(Which : Byte);
Var
  i,
  n,
  v,
  w,
  Mask : Word;
  TempX,
  TempY,
  LdCmd,
  RdCmd : Byte;
Begin
  IF Which = ProgMem THEN
  Begin
    n := ProgSize;
    Mask := $3FFF;
    LdCmd := LdProg;
    RdCmd := RdProg;
  End
  ELSE
  Begin
    n := DataSize;
    Mask := $FF;
    LdCmd := LdData;
    RdCmd := RdData;
  End;
  IF Which = ProgMem THEN
    Write('Writing program data   : ')
  ELSE
    Write('Writing EEPROM data   : ');
  TempX := WhereX;
  TempY := WhereY;
  ProgMode(On);
  FOR i := 0 TO n - 1 Do
  Begin
    GotoXY(TempX, TempY);
    Command(LdCmd);
    IF Which = ProgMem THEN
    Begin
      v := ProgBuf[i];
      Write(i);
    End
    ELSE
    Begin
      v := DataBuf[i];
      Write(i);
    End;
    OutWord(v);
    Command(BegPrg);        {Program word}
    Delay(PrgDly);
    Command(RdCmd);         {Read word back for verify}
    w := InWord AND Mask;
    IF v <> w THEN          {If verify fail, quit with error}
      Quit(ERRPRG, v, w, i);
    Command(IncAdd);
  End;
End;

Procedure TestForHardware;
Var
  BitHi,
  BitLo : Byte;
Begin
  Port[LptPort] := p0101;  {Turn VddOn}
  Delay(VppDly);
  BitHi := (Port[LptPort + 1] AND DataIn) XOR DataInv;
  Port[LptPort] := p0000;
  BitLo := (Port[LptPort + 1] AND DataIn) XOR DataInv;
  IF (BitHi <> DataIn) OR (BitLo <> 0) THEN
    Quit(ERRHWF, 0, 0, 0);
End;

FUNCTION Yes(A : String) : Boolean;
Begin
  IF (A = 'Y') OR (A = 'y') THEN
    Yes := TRUE
  ELSE
    Yes := FALSE;
End;

Procedure EraseAll;
Var
  i : Byte;
Begin
  ProgMode(On);
  Command(LdConf);
  OutWord($3FFF);
  FOR i := 0 TO 6 Do
    Command(IncAdd);
  Command(1);
  Command(7);
  Command(BegPrg);
  Delay(PrgDly);
  Command(1);
  Command(7);
  ProgMode(Off);
End;

Procedure Verify(Which : Byte);
Var
  Mask,
  i,
  v,
  w,
  n : Word;
  TempX,
  TempY,
  RdCmd : Byte;
Begin
  ProgMode(On);
  IF Which = ProgMem THEN
  Begin
    n := ProgSize;
    Mask := $3FFF;
    RdCmd := RdProg;
  End
  ELSE
  Begin
    n := DataSize;
    Mask := $FF;
    RdCmd := RdData;
  End;
  IF Which = ProgMem THEN
    Write('Verifying program data : ')
  ELSE
    Write('Verifying EEPROM data : ');
  TempX := WhereX;
  TempY := WhereY;
  FOR i := 0 TO n - 1 Do
  Begin
    GotoXY(TempX, TempY);
    IF Which = ProgMem THEN
    Begin
      v := ProgBuf[i];
      Write(i);
    End
    ELSE
    Begin
      v := DataBuf[i];
      Write(i);
    End;
    Command(RdCmd);
    w := InWord AND Mask;
    IF v <> w THEN
      Quit(ERRVER, v, w, i);
    Command(IncAdd);
  End;
End;

Procedure Read(Which : Byte);
Var
  Mask,
  i,
  v,
  w,
  n : Word;
  TempX,
  TempY,
  RdCmd : Byte;
Begin
  TempX := WhereX;
  TempY := WhereY;
  IF Which = ProgMem THEN
  Begin
    n := ProgSize;
    Mask := $3FFF;
    RdCmd := RdProg;
  End
  ELSE
  Begin
    n := DataSize;
    Mask := $FF;
    RdCmd := RdData;
  End;
  ProgMode(On);
  FOR i := 0 TO n - 1 Do
  Begin
    GotoXY(TempX, TempY);
    Command(RdCmd);
    w := InWord AND Mask;
    IF Which = ProgMem THEN
    Begin
      RdProgBuf[i] := w;
      Write('Reading program data : ', i);
    End
    ELSE
    Begin
      RdDataBuf[i] := w;
      Write('Reading EEPROM data : ', i);
    End;
    Command(IncAdd);
  End;
  WriteLN;
End;

Procedure DisplayBuf(Which, BufType, Page : Byte);
Var
  PageSize,
  Mask,
  i,
  v,
  w,
  n : Word;
  RdCmd : Byte;
Begin
  IF Which = ProgMem THEN
  Begin
    n := ProgSize;
    PageSize := 255;
    Mask := $3FFF;
    RdCmd := RdProg;
  End
  ELSE
  Begin
    n := DataSize;
    PageSize := Datasize-1;
    Mask := $FF;
    RdCmd := RdData;
  End;
  If BufType = 1 Then
  Begin
    FOR i := Page*256 TO (Page*256) + PageSize{n - 1} Do
    Begin
      IF Which = ProgMem THEN
        Write(WordHexs(ProgBuf[i]), ' ')
      ELSE
        Write(WordHexs(DataBuf[i]));
    End;
  End
  Else
  Begin
    FOR i := 0 TO 255{n - 1} Do
    Begin
      IF Which = ProgMem THEN
        Write(WordHexs(RdProgBuf[i]), ' ')
      ELSE
        Write(WordHexs(RdDataBuf[i]));
    End;
  End;
End;


Procedure Config;
Var
  i : Byte;
Begin
  ProgMode(On);
  Command(LdConf);
  OutWord(Fuses);
  FOR i := 1 TO 7 Do
    Command(IncAdd);
  Command(LdProg);
  OutWord(Fuses);
  Command(BegPrg);
  Delay(PrgDly);
  Command(RdProg);
  i := InWord AND $1F;
  {IF Fuses <> i THEN
    Quit(ERRFSE, Fuses, i, 0);}
End;


Procedure ProgramAll;
Begin
  WriteLN;
  ClockOn;
  EraseAll;
  Write('Programming ...    ');
  ProgramChip(ProgMem);
  Write('  ');
  {IF DataLoaded THEN
    ProgramChip(DataMem);}
  WriteLN;
  Write('Verifying ...      ');
  Verify(ProgMem);
  Write('  ');
{  IF DataLoaded THEN
    Verify(DataMem);}
  WriteLN;
  WriteLN('Blowing Fuses to 0x', HEXS(Fuses), ' ...');
  Config;
  ProgMode(Off);
  WriteLN('Total time ', ClockOff, ' secs.');
End;

Procedure ClrBuffers;
Var
  i : Word;
Begin
  TestForHardware;
  FOR i := 0 TO ProgSize - 1 Do
    ProgBuf[i] := $3FFF;
  FOR i := 0 TO DataSize - 1 Do
    DataBuf[i] := $FF;
End;


Procedure UserInput;
Var
  A : String;
Begin
{  COLOR(Scolor, Scolor);}
  HF := InName;
  Write('Enter program filename to load : (default "', InName, '") ');
  ReadLN(A);
  If Length(A) > 0 Then
    HF := A;
  IF Length(HF) > 0 THEN
  Begin
    LoadHex(HF, ProgMem, ProgSize);
    ProgLoaded := TRUE;
  End
  ELSE
    Quit( ERRNOF, 0, 0, 0);
  Write('Enter data filename to load : (default "', DF, '") ');
  ReadLN(A);
  If Length(A) > 0 Then
    DF := A;
  IF Length(DF) > 0 THEN
  Begin
    LoadHex(DF, DataMem, DataSize);
    DataLoaded := TRUE;
  End;
  AskFuses;
End;

Procedure ShowStats;
Var
  WDStr : String4;
Begin
  If WT = 'Y' Then
    WDStr := 'Yes'
  Else
    WdStr := 'No';
  WriteAt(WDTPosX, WDTPosY, WDStr);
  If PT = 'Y' Then
    WDStr := 'Yes'
  Else
    WdStr := 'No';
  WriteAt(PutPosX, PutPosY, WDStr);
  If Code = 'Y' Then
    WDStr := 'Yes'
  Else
    WdStr := 'No';
  WriteAt(CPPosX, CPPosY, WDStr);
  WriteAt(PortPosX, PortPosY, PP);
  WriteAt(HexPosX, HexPosY, HE);
  If ProgLoaded Then
    WriteAt(FNmPosX, FNmPosY, HF);
  If DataLoaded Then
    WriteAt(DNmPosX, DNmPosY, DF);
End;

Procedure Initialize;
Begin
   HexType := INHX8M;
   HE := 'INHX8M';
   Fuses := 0;
   Check := 0;
   ProgLoaded := FALSE;
   DataLoaded := FALSE;
 { HexType := INHX16;
  HE :=  'INHX16';}
  HF := 'PROGRAM.OBJ';{            'Object file in Hex format.             }
  DF := 'DATA.HEX';{               'EEPROM Data file in Hex format.        
  'Ĵ
  'OSC$ = "LP"                     'Oscillator Type LP                     }
   Osc := XT;                     {'Oscillator Type XT                     
  'OSC$ = "HS"                     'Oscillator Type HS                     
  'OSC$ = "RC"                     'Oscillator Type RC                     
  'Ĵ}
  WT := 'N';{                      'Watch-Dog Timer Off                    }
  {WT := 'Y';}{                       'Watch-Dog Timer On                     
  'Ĵ}
  PT := 'N'; {                     'Power-Up Timer Off                     
  'PT$ = "Y"                       'Power-Up Timer On                      
  'Ĵ}
  CODE := 'N';{                    'Code Protection Off                    
  'CODE$ = "Y"                     'Code Protection On                     
  '}
  {ClrScr;
  WriteLN;
  WriteLN('Turbo Pascal Version by Nigel Goodwin. 16-Jul-95 Copyright.');
  WriteLN('Based On PIC84PGM.BAS by Don McKenzie & David Tate.');
  WriteLN;}
  {Auto-detect printer port added. DonMac}
  LptPort := $378;
  PP := '$378';
 { Port[LptPort] := p0101;
  Delay(VppDly);
  BitHi := (Port[LptPort + 1] AND DataIn) XOR DataInv;
  Port[LptPort] := p0000;
  BitLo = (INP(LptPort + 1) AND DataIn) XOR DataInv
  IF (BitHi <> DataIn) OR (BitLo <> 0) THEN GOTO TRY378 ELSE GOTO Main
TRY378:
  LptPort = &H378: PP$ = "378Hex."
  OUT LptPort, p0101  ' VddOn
  VppDly
  BitHi = (INP(LptPort + 1) AND DataIn) XOR DataInv
  OUT LptPort, p0000
  BitLo = (INP(LptPort + 1) AND DataIn) XOR DataInv
  IF (BitHi <> DataIn) OR (BitLo <> 0) THEN GOTO TRY3BC ELSE GOTO Main
TRY3BC:
  LptPort = &H3BC: PP$ = "3BCHex."
  OUT LptPort, p0101  ' VddOn
  VppDly
  BitHi = (INP(LptPort + 1) AND DataIn) XOR DataInv
  OUT LptPort, p0000
  BitLo = (INP(LptPort + 1) AND DataIn) XOR DataInv
  IF (BitHi <> DataIn) OR (BitLo <> 0) THEN Quit ERRHWF, 0, 0, 0 }
  {'DonMac.001}
  COLOR(Bcolor, Fcolor);
  ClrScr;
  WriteLN('  ', ProgName, '       Version ', Version, '       ', Copyright, ' ');
  GotoXY(1, 2);
  WriteLN('     Ŀ');
  WriteLN('      WDT :     PUT :     CP :     Port :        File Type :         ');
  WriteLN('     ');
  WriteLN('       Prog Data Loaded :               Hex Data Loaded :              ');
  WriteLN('      ');
  Window(1,7,80,24);
  COLOR(Fcolor, Bcolor);
  ClrScr;
  WriteLN;
  WriteLN;
  ClrBuffers;
End;

Procedure Menu;
Var
  Ch : Char;
  Finished : Boolean;
Begin
  WriteLN;
  WriteLN('1 : Read Obj file from disk.');
  WriteLN('2 : Program target 16C84.');
  WriteLN('3 : Verify programmed 16C84');
  WriteLN('4 : Read data from 16C84.');
  WriteLN('5 : Display program in Write Buffer.');
  WriteLN('6 : Display program in Read Buffer.');
  WriteLN('7 : Display data in Write Buffer.');
  WriteLN;
  WriteLN('0 : Exit programme.');
  Finished := False;
  Repeat
    Ch := ReadKey;
    Case Ch Of
      '1' : UserInput;
      '2' : ProgramAll;
      '3' : Verify(ProgMem);
      '4' : Read(ProgMem);
      '5' : DisplayBuf(ProgMem, 1, 0);
      '6' : DisplayBuf(ProgMem, 2, 0);
      '7' : DisplayBuf(DataMem, 1, 0);
      '0' : Finished := True;
    End;
  Until Finished;
End;

Procedure ClearUp;
Begin
  Window(1, 1, 80, 25);
  Halt;
End;

Begin
  Initialize;
  UserInput;
  Menu;
  ClearUp;
End.